<?php
namespace Neuron\Person\Controller;

class Status extends \Neuron\Person\Controller {

	public function listAction() {
		$storage = \Neuron\Person\Status\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Status($storage);

		$post = $this->getPostParams();
		$arr = $cpar->listStatus($post['start'], $post['length'], 
								array(	'field'		=> $post['field'], 
										'value'		=>$post['search']['value'], 
										'order' 	=> array(
											'columnName' 	=> $post['columns'][$post['order'][0]['column']]['data'],
											'dir' 			=> $post['order'][0]['dir']
										)
								));
		$params = array();
		if ($arr['data']) {
				foreach ($arr['data'] as $data) {
						array_push($params, $data);
				}
		}
		$result = array('draw'=>$post['draw'],
						'recordsFiltered'=>intval($arr['total']),
						'recordsTotal'=>intval($arr['total']),
						'data'=>$params
						);
		echo json_encode($result);
		return $this->getResponse();
	}

	public function saveAction(){
		$sessmgt = $this->getSession()->get();
		$post 		= $this->getREST()->getParameters();
		$status 	= new \Neuron\Person\Status(
			\Neuron\Person\Status\Storage::factory(
				$this->getDb(),
				$this->getConfig()
			)
		);
		$result 	= $status->saveEx($post);

		$generic 	= new \Neuron\Person\Generic;
		$cache 		= $generic->getCacheAdapter();
		$cache->removeItem(md5(\Neuron\Person\Status::CACHE_HASH));

		$result->info = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}
	public function deleteAction(){
		$sessmgt = $this->getSession()->get();
		$post= $this->getPostParams();
		$storage = \Neuron\Person\Status\Storage::factory($this->getDb(), $this->getConfig());
		$cstatus = new \Neuron\Person\Status($storage);
		$delete = $cstatus->remove($post['status_id']);

		// Clear cache
		$generic 	= new \Neuron\Person\Generic;
		$cache 		= $generic->getCacheAdapter();
		$cache->removeItem(md5(\Neuron\Person\Status::CACHE_HASH));

		echo json_encode($delete);
		return $this->getResponse();

	}
}