<?php
namespace Neuron\Employee\Controller\Widget;
use Neuron\Access\Session;

class Wdashboard extends \Neuron\Employee\Controller\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/employee/layout/plain');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/employee/widget/dashboard';

		/* libraries */
		$this->using('popper',11);
		$this->using('fontawesome', 12);
		$this->using('nicescroll', 13);
		$this->using('toast', 14);

		$this->using('datatable', 15);
		$this->using('air-datepicker', 16);
		$this->using('jquery.validate', 17);
		$this->using('moment', 18);
		$this->using('chart.js', 19);

        $config = $this->getConfig();
        
		if (isset($config['employee'])) {
			$config = $config['employee'];
            $prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
        $view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder

		return $view;
	}
	
	public function WidgetEmployeeInformationAction(){
        $widgettitle = $this->translate("Widget Employee Information");
        return $this->getViewPartial('widget-employee-information', get_defined_vars());
	}

    public function ChartEmployeeByDeptAction(){
        return $this->getViewPartial('chart-employee-departement', get_defined_vars());
	}

	public function ChartEmployeeByTypeAction(){
        return $this->getViewPartial('chart-employee-type', get_defined_vars());
	}

	public function ChartEmployeeByGenderAction() {
        return $this->getViewPartial('chart-employee-gender', get_defined_vars());
	}
	
	//WIDGET B
	public function WidgetContractNearExpiredAction(){
		$title = $this->translate("Layout Widget Employee Contract Will End");
        return $this->getViewPartial('widget-contract-near-expired', get_defined_vars());
	}
	public function ListContractNearExpiredAction(){
		return $this->getViewPartial('list-contract-near-expired', get_defined_vars());
	}
}